import * as i4 from '@angular/cdk/overlay';
import { CdkConnectedOverlay, OverlayModule } from '@angular/cdk/overlay';
import * as i3 from '@angular/forms';
import { FormGroup, FormControl, NG_VALUE_ACCESSOR, ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i0 from '@angular/core';
import { Component, ViewEncapsulation, Inject, HostBinding, Input, HostListener, EventEmitter, ChangeDetectionStrategy, Output, ViewChild, ContentChildren, NgModule } from '@angular/core';
import { ActiveDescendantKeyManager } from '@angular/cdk/a11y';
import { take, debounceTime, takeUntil } from 'rxjs/operators';
import { DOWN_ARROW, UP_ARROW, LEFT_ARROW, RIGHT_ARROW, ENTER, SPACE, hasModifierKey } from '@angular/cdk/keycodes';
import { Subject } from 'rxjs';
import { trigger, transition, style, animate } from '@angular/animations';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1 from '@angular/cdk/scrolling';
import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

const selectReveal = trigger('selectAnim', [
    transition('void => *', [
        style({
            opacity: 0,
            visibility: 'hidden',
            height: '0px',
        }),
        animate('100ms ease-in-out', style({
            opacity: 1,
            visibility: 'visible',
            height: '*',
        })),
    ]),
    transition('* => void', [
        animate('100ms ease-in-out', style({
            opacity: 0,
            visibility: 'hidden',
            height: '0px',
        })),
    ]),
]);

class AtSelectOptionComponent {
    constructor(elementRef, parent) {
        this.elementRef = elementRef;
        this.parent = parent;
        this.active = false;
    }
    get selected() {
        return this.parent.selectedOption === this;
    }
    onSelect(event) {
        // console.log('on select in option component');
        event.preventDefault();
        event.stopPropagation();
        this.parent.onSelect(this);
    }
    ngOnInit() {
    }
    ngAfterViewInit() {
        if (this.parent.value === this.value) {
            this.parent.onSelect(this);
        }
    }
    setActiveStyles() {
        this.focus();
        this.active = true;
    }
    setInactiveStyles() {
        this.active = false;
    }
    getLabel() {
        return this.value;
    }
    focus(options) {
        this.elementRef.nativeElement.focus(options);
    }
}
AtSelectOptionComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectOptionComponent, deps: [{ token: i0.ElementRef }, { token: AtSelectComponent }], target: i0.ɵɵFactoryTarget.Component });
AtSelectOptionComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.3", type: AtSelectOptionComponent, selector: "at-select-option", inputs: { value: "value", label: "label" }, host: { listeners: { "click": "onSelect($event)" }, properties: { "class.selected": "this.selected", "class.active": "this.active" } }, ngImport: i0, template: "<style>\r\n  :host {\r\n    position: relative;\r\n    display: block;\r\n    max-width: 100%;\r\n    height: 100%;\r\n    white-space: nowrap;\r\n    cursor: pointer;\r\n    box-sizing: border-box;\r\n    padding: 10px;\r\n    border-radius: 3px;\r\n    transition: all 150ms ease;\r\n  }\r\n\r\n  .select-label { \r\n    padding: 5px;\r\n  }\r\n\r\n  .select-label:hover {\r\n    background-color: rgb(225, 227, 222);\r\n  }\r\n\r\n  .active {\r\n    background-color: #eee;\r\n  }\r\n</style>\r\n\r\n<div class=\"select-label\">\r\n  <ng-container *ngIf=\"label; else content\"></ng-container>\r\n  {{ label }}\r\n  <ng-template #content>\r\n    <ng-content></ng-content>\r\n  </ng-template>\r\n</div>", styles: ["\n  :host {\n    position: relative;\n    display: block;\n    max-width: 100%;\n    height: 100%;\n    white-space: nowrap;\n    cursor: pointer;\n    box-sizing: border-box;\n    padding: 10px;\n    border-radius: 3px;\n    transition: all 150ms ease;\n  }\n\n  .select-label { \n    padding: 5px;\n  }\n\n  .select-label:hover {\n    background-color: rgb(225, 227, 222);\n  }\n\n  .active {\n    background-color: #eee;\n  }\n"], dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectOptionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'at-select-option', encapsulation: ViewEncapsulation.None, template: "<style>\r\n  :host {\r\n    position: relative;\r\n    display: block;\r\n    max-width: 100%;\r\n    height: 100%;\r\n    white-space: nowrap;\r\n    cursor: pointer;\r\n    box-sizing: border-box;\r\n    padding: 10px;\r\n    border-radius: 3px;\r\n    transition: all 150ms ease;\r\n  }\r\n\r\n  .select-label { \r\n    padding: 5px;\r\n  }\r\n\r\n  .select-label:hover {\r\n    background-color: rgb(225, 227, 222);\r\n  }\r\n\r\n  .active {\r\n    background-color: #eee;\r\n  }\r\n</style>\r\n\r\n<div class=\"select-label\">\r\n  <ng-container *ngIf=\"label; else content\"></ng-container>\r\n  {{ label }}\r\n  <ng-template #content>\r\n    <ng-content></ng-content>\r\n  </ng-template>\r\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: AtSelectComponent, decorators: [{
                    type: Inject,
                    args: [AtSelectComponent]
                }] }]; }, propDecorators: { selected: [{
                type: HostBinding,
                args: ['class.selected']
            }], value: [{
                type: Input
            }], label: [{
                type: Input
            }], active: [{
                type: HostBinding,
                args: ['class.active']
            }], onSelect: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

const SELECT_PANEL_HEIGHT = 256;
const SELECT_PANEL_PADDING = 5;
const SELECT_OPTION_HEIGHT = 39;
class AtSelectComponent {
    constructor(elementRef, changeDetectorRef, viewportRuler) {
        this.elementRef = elementRef;
        this.changeDetectorRef = changeDetectorRef;
        this.viewportRuler = viewportRuler;
        this.isLast = false;
        this.isLoading = false;
        this.placeholder = 'Please select ...';
        this.isReadonly = false;
        this.panelOpen = false;
        this.focused = false;
        this.isDissabled = false;
        this.searchForm = new FormGroup({
            search: new FormControl()
        });
        this.filterQuery = new EventEmitter();
        this.takeNextPage = new EventEmitter();
        this.onSelectValue = new EventEmitter();
        this.tabIndex = 0;
        this.role = 'combobox';
        this.autocomplete = 'none';
        this.destroy$ = new Subject();
    }
    get empty() {
        return !this.selectedOption;
    }
    onKeyDown(event) {
        this.panelOpen
            ? this.handleOpenKeyDown(event)
            : this.handleClosedKeyDown(event);
    }
    onFocus() {
        // console.log('listening on focus');
        if (!this.isDissabled) {
            this.focused = true;
        }
    }
    onBlur() {
        // console.log('listening on blur');
        this.focused = false;
        if (!this.isDissabled && !this.panelOpen) {
            this.changeDetectorRef.markForCheck();
        }
    }
    writeValue(value) {
        // console.log('value in write value: ', value);
        this.value = value;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.isDissabled = isDisabled;
    }
    ngOnInit() {
        this.prepareViewportRuler();
        this.onFilter();
        // this.onPreSelected();
    }
    ngAfterContentInit() {
        this.initKeyManager();
        // console.log('value: ', this.value);
    }
    onRefresh() {
        if (this.displayOption) {
            this.displayOption.value = null;
        }
    }
    onAttach() {
        this.connectedOverlay.positionChange.pipe(take(1)).subscribe(() => {
            this.changeDetectorRef.detectChanges();
            this.highlightOption();
            if (this.panelOpen && this.panel) {
                this.scrollPosition(this.keyManager.activeItemIndex || 0);
            }
        });
    }
    onSelect(option) {
        // console.log('ON SELECT in select: ', option);
        this.keyManager.setActiveItem(option);
        this.selectedOption = option;
        this.displayOption = { value: option.label };
        this.onSelectValue.emit(option.value);
        this.value = option.value;
        this.onChange(this.value);
        this.close();
        this.focus();
        this.changeDetectorRef.markForCheck();
    }
    onFilter() {
        this.searchForm.controls.search.valueChanges.pipe(debounceTime(400)).subscribe(val => {
            // console.log('ON filter', val);
            this.filterQuery.emit(val);
        });
    }
    onScroll(event) {
        const target = event.target;
        let percentage = target.scrollTop / target.scrollTopMax * 100;
        // console.log(Math.round(percentage), '% data is loaded');
        // console.log('isLoading', this.isLoading);
        if (percentage > 80 && !this.isLast && !this.isLoading) {
            // console.log('is Last', this.isLast);
            this.takeNextPage.emit();
        }
    }
    onOpen() {
        //   console.log('opening');
        this.updateRect();
        this.searchForm.controls.search.reset();
        this.highlightOption();
        this.keyManager.withHorizontalOrientation(null);
        this.panelOpen = !this.panelOpen;
    }
    close() {
        if (this.panelOpen) {
            this.panelOpen = false;
            this.changeDetectorRef.markForCheck();
        }
    }
    ngOnDestroy() {
        this.destroy$.next();
        this.destroy$.complete();
        // console.log('calling after view inint');
    }
    // onPreSelected(){
    //     console.log('this.slelctedOption', this.selectedOption);
    //     if(this.value){
    //         this.selectedOption.value = this.value;
    //         console.log('this.slelctedOption', this.selectedOption);
    //     }
    // }
    prepareViewportRuler() {
        this.viewportRuler
            .change()
            .pipe(takeUntil(this.destroy$))
            .subscribe(() => {
            if (this.panelOpen) {
                this.triggerRect = this.trigger.nativeElement.getBoundingClientRect();
                this.changeDetectorRef.markForCheck();
            }
        });
    }
    initKeyManager() {
        this.keyManager = new ActiveDescendantKeyManager(this.selectOptions)
            .withTypeAhead()
            .withVerticalOrientation(true)
            .withHorizontalOrientation('ltr')
            .withHomeAndEnd()
            .withAllowedModifierKeys(['shiftKey']);
        this.keyManager.tabOut.pipe(takeUntil(this.destroy$)).subscribe(() => {
            this.focus();
            this.close();
        });
    }
    handleClosedKeyDown(event) {
        const keyCode = event.keyCode;
        const isArrowKey = keyCode === DOWN_ARROW ||
            keyCode === UP_ARROW ||
            keyCode === LEFT_ARROW ||
            keyCode === RIGHT_ARROW;
        const isOpenKey = keyCode === ENTER || keyCode === SPACE;
        const manager = this.keyManager;
        if ((!manager.isTyping() && isOpenKey && !hasModifierKey(event)) ||
            (event.altKey && isArrowKey)) {
            event.preventDefault();
            this.panelOpen = true;
        }
        else {
            manager.onKeydown(event);
        }
    }
    handleOpenKeyDown(event) {
        const manager = this.keyManager;
        const keyCode = event.keyCode;
        const isArrowKey = keyCode === DOWN_ARROW || keyCode === UP_ARROW;
        const isTyping = manager.isTyping();
        if (isArrowKey && event.altKey) {
            // Close the select on ALT + arrow key to match the native <select>
            event.preventDefault();
            this.close();
        }
        else if (!isTyping &&
            (keyCode === ENTER || keyCode === SPACE)
            && manager.activeItem
            && !hasModifierKey(event)) {
            event.preventDefault();
            this.onSelect(manager.activeItem);
        }
        else {
            manager.onKeydown(event);
            if (this.panelOpen && this.panel) {
                this.scrollPosition(this.keyManager.activeItemIndex || 0);
            }
        }
        this.changeDetectorRef.markForCheck();
    }
    focus(options) {
        this.elementRef.nativeElement.focus(options);
    }
    highlightOption() {
        if (this.keyManager) {
            if (this.empty) {
                this.keyManager.setFirstItemActive();
            }
            else {
                this.keyManager.setActiveItem(this.selectedOption);
            }
        }
    }
    scrollPosition(index) {
        if (index === 0) {
            this.panel.nativeElement.scrollTop = 0;
        }
        else {
            this.panel.nativeElement.scrollTop =
                SELECT_OPTION_HEIGHT * index +
                    (SELECT_OPTION_HEIGHT - SELECT_PANEL_PADDING) -
                    Math.ceil(SELECT_PANEL_HEIGHT / 2);
        }
    }
    updateRect() {
        this.triggerRect = this.trigger.nativeElement.getBoundingClientRect();
    }
}
AtSelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i1.ViewportRuler }], target: i0.ɵɵFactoryTarget.Component });
AtSelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.3", type: AtSelectComponent, selector: "at-select", inputs: { isLast: "isLast", isLoading: "isLoading", placeholder: "placeholder", formControl: "formControl" }, outputs: { filterQuery: "filterQuery", takeNextPage: "takeNextPage", onSelectValue: "onSelectValue" }, host: { listeners: { "keydown": "onKeyDown($event)", "focus": "onFocus()", "blur": "onBlur()" }, properties: { "attr.tabIndex": "this.tabIndex", "attr.role": "this.role", "attr.aria-autocomplete": "this.autocomplete" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: AtSelectComponent,
            multi: true
        }
    ], queries: [{ propertyName: "selectOptions", predicate: AtSelectOptionComponent, descendants: true }], viewQueries: [{ propertyName: "trigger", first: true, predicate: ["trigger"], descendants: true }, { propertyName: "connectedOverlay", first: true, predicate: CdkConnectedOverlay, descendants: true, static: true }, { propertyName: "panel", first: true, predicate: ["panel"], descendants: true }], ngImport: i0, template: "<style>\r\n  .select-trigger {\r\n    width: 100%;\r\n    height: 45px;\r\n    display: flex;\r\n    align-items: center;\r\n    padding: 5px;\r\n    padding-left: 10px;\r\n    cursor: pointer;\r\n    overflow: hidden;\r\n    transition: all 100ms ease;\r\n    border-radius: 3px;\r\n    border: 1px solid grey;\r\n    background-color: white;\r\n    color: rgb(48, 44, 44);\r\n  }\r\n\r\n  .select-trigger:active {\r\n    z-index: auto;\r\n    border-color: rgb(233, 176, 69) !important;\r\n    box-shadow: inset 0 0 0 1px rgb(233, 176, 69), inset 0 0 0 2px rgb(233, 176, 69) !important;\r\n    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out;\r\n  }\r\n\r\n  .select-trigger:focus {\r\n    z-index: auto;\r\n    border-color: orange !important;\r\n    box-shadow: inset 0 0 0 1px rgb(233, 176, 69), inset 0 0 0 2px rgb(233, 176, 69) !important;\r\n    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out;\r\n  }\r\n\r\n  .select-trigger:disabled {\r\n    border: 1px solid gray;\r\n    color: grey;\r\n    pointer-events: none;\r\n  }\r\n\r\n  .select-arrow {\r\n    margin-left: auto;\r\n    margin-right: 20px;\r\n    transition: all 150ms ease;\r\n  }\r\n\r\n  .caret-down {\r\n    background-image: url('data:image/svg+xml;utf8, <svg focusable=\"false\" viewBox=\"0 0 16 16\" xmlns=\"http://www.w3.org/2000/svg\" name=\"chevron-down\" aria-label=\"Close menu\" role=\"img\"><path d=\"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z\"/></svg>');\r\n    background-position: center center;\r\n    background-size: cover;\r\n    background-repeat: no-repeat;\r\n    width: 15px;\r\n    height: 15px;\r\n    transform: rotate(0deg);\r\n  }\r\n\r\n  .caret-up {\r\n    background-image: url('data:image/svg+xml;utf8, <svg focusable=\"false\" viewBox=\"0 0 16 16\" xmlns=\"http://www.w3.org/2000/svg\" name=\"chevron-down\" aria-label=\"Close menu\" role=\"img\"><path d=\"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z\"/></svg>');\r\n    background-position: center center;\r\n    background-size: cover;\r\n    background-repeat: no-repeat;\r\n    width: 15px;\r\n    height: 15px;\r\n    transform: rotate(180deg);\r\n  }\r\n\r\n  .select-panel-wrap {\r\n    width: inherit;\r\n    height: inherit;\r\n    border: 1px gray solid;\r\n    border-radius: 3px;\r\n  }\r\n\r\n  .select-panel {\r\n    display: flex;\r\n    flex-direction: column;\r\n    padding: 5px;\r\n    overflow: auto;\r\n    max-height: 150px;\r\n    border: unset;\r\n  }\r\n\r\n  .search-input {\r\n    height: 48px;\r\n    padding-left: 10px;\r\n    width: 100%;\r\n    border-left: unset;\r\n    border-right: unset;\r\n  }\r\n\r\n  .placeholder {\r\n    color: #a2a2a2;\r\n    font-weight: lighter;\r\n  }\r\n\r\n  .option {\r\n    padding: 10px;\r\n  }\r\n\r\n  .select-value {\r\n    padding: 10px;\r\n  }\r\n\r\n</style>\r\n\r\n\r\n<div (ngModelChange)=\"onChange($event)\" name=\"select\"  class=\"select-trigger\" [ngClass]=\"{ active: panelOpen, focus: focused, dissable: isDissabled }\" (click)=\"onOpen()\"\r\n  cdkOverlayOrigin #origin=\"cdkOverlayOrigin\" #trigger>\r\n  <div class=\"select-value\">\r\n    {{ displayOption ? displayOption.value : \"\" }}\r\n  </div>\r\n\r\n  <div *ngIf=\"!displayOption?.value\" class=\"placeholder\">\r\n    {{ placeholder }}\r\n  </div>\r\n  <div class=\"select-arrow\" [ngClass]=\"{ 'caret-down': !panelOpen, 'caret-up': panelOpen }\"></div>\r\n</div>\r\n<ng-template cdkConnectedOverlay cdkConnectedOverlayHasBackdrop cdkConnectedOverlayLockPosition\r\n  cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\" [cdkConnectedOverlayOrigin]=\"origin\"\r\n  [cdkConnectedOverlayOpen]=\"panelOpen\" [cdkConnectedOverlayWidth]=\"triggerRect?.width\" (backdropClick)=\"close()\"\r\n  (attach)=\"onAttach()\">\r\n  <div class=\"select-panel-wrap\" [formGroup]=\"searchForm\" [@selectAnim]>\r\n    <div class=\"eui-input-group-addon\">\r\n      <input class=\"search-input\" formControlName=\"search\" id=\"text-model-driven-addon\" placeholder=\"search...\" />\r\n      <div *ngIf=\"!isReadonly\" class=\"eui-input-group-addon-item\"><span euiIcon\r\n          iconClass=\"eui-icon eui-icon-search\"></span></div>\r\n    </div>\r\n    <div class=\"select-panel\" tabindex=\"-1\" role=\"listbox\" #panel\r\n      (scroll)=\"!isLoading && !isLast? onScroll($event) : ''\">\r\n      <ng-content class=\"option\"></ng-content>\r\n    </div>\r\n  </div>\r\n</ng-template>", styles: ["\n  .select-trigger {\n    width: 100%;\n    height: 45px;\n    display: flex;\n    align-items: center;\n    padding: 5px;\n    padding-left: 10px;\n    cursor: pointer;\n    overflow: hidden;\n    transition: all 100ms ease;\n    border-radius: 3px;\n    border: 1px solid grey;\n    background-color: white;\n    color: rgb(48, 44, 44);\n  }\n\n  .select-trigger:active {\n    z-index: auto;\n    border-color: rgb(233, 176, 69) !important;\n    box-shadow: inset 0 0 0 1px rgb(233, 176, 69), inset 0 0 0 2px rgb(233, 176, 69) !important;\n    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out;\n  }\n\n  .select-trigger:focus {\n    z-index: auto;\n    border-color: orange !important;\n    box-shadow: inset 0 0 0 1px rgb(233, 176, 69), inset 0 0 0 2px rgb(233, 176, 69) !important;\n    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out;\n  }\n\n  .select-trigger:disabled {\n    border: 1px solid gray;\n    color: grey;\n    pointer-events: none;\n  }\n\n  .select-arrow {\n    margin-left: auto;\n    margin-right: 20px;\n    transition: all 150ms ease;\n  }\n\n  .caret-down {\n    background-image: url('data:image/svg+xml;utf8, <svg focusable=\"false\" viewBox=\"0 0 16 16\" xmlns=\"http://www.w3.org/2000/svg\" name=\"chevron-down\" aria-label=\"Close menu\" role=\"img\"><path d=\"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z\"/></svg>');\n    background-position: center center;\n    background-size: cover;\n    background-repeat: no-repeat;\n    width: 15px;\n    height: 15px;\n    transform: rotate(0deg);\n  }\n\n  .caret-up {\n    background-image: url('data:image/svg+xml;utf8, <svg focusable=\"false\" viewBox=\"0 0 16 16\" xmlns=\"http://www.w3.org/2000/svg\" name=\"chevron-down\" aria-label=\"Close menu\" role=\"img\"><path d=\"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z\"/></svg>');\n    background-position: center center;\n    background-size: cover;\n    background-repeat: no-repeat;\n    width: 15px;\n    height: 15px;\n    transform: rotate(180deg);\n  }\n\n  .select-panel-wrap {\n    width: inherit;\n    height: inherit;\n    border: 1px gray solid;\n    border-radius: 3px;\n  }\n\n  .select-panel {\n    display: flex;\n    flex-direction: column;\n    padding: 5px;\n    overflow: auto;\n    max-height: 150px;\n    border: unset;\n  }\n\n  .search-input {\n    height: 48px;\n    padding-left: 10px;\n    width: 100%;\n    border-left: unset;\n    border-right: unset;\n  }\n\n  .placeholder {\n    color: #a2a2a2;\n    font-weight: lighter;\n  }\n\n  .option {\n    padding: 10px;\n  }\n\n  .select-value {\n    padding: 10px;\n  }\n\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i3.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i3.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "directive", type: i4.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i4.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }], animations: [selectReveal], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'at-select', animations: [selectReveal], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: AtSelectComponent,
                            multi: true
                        }
                    ], template: "<style>\r\n  .select-trigger {\r\n    width: 100%;\r\n    height: 45px;\r\n    display: flex;\r\n    align-items: center;\r\n    padding: 5px;\r\n    padding-left: 10px;\r\n    cursor: pointer;\r\n    overflow: hidden;\r\n    transition: all 100ms ease;\r\n    border-radius: 3px;\r\n    border: 1px solid grey;\r\n    background-color: white;\r\n    color: rgb(48, 44, 44);\r\n  }\r\n\r\n  .select-trigger:active {\r\n    z-index: auto;\r\n    border-color: rgb(233, 176, 69) !important;\r\n    box-shadow: inset 0 0 0 1px rgb(233, 176, 69), inset 0 0 0 2px rgb(233, 176, 69) !important;\r\n    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out;\r\n  }\r\n\r\n  .select-trigger:focus {\r\n    z-index: auto;\r\n    border-color: orange !important;\r\n    box-shadow: inset 0 0 0 1px rgb(233, 176, 69), inset 0 0 0 2px rgb(233, 176, 69) !important;\r\n    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out;\r\n  }\r\n\r\n  .select-trigger:disabled {\r\n    border: 1px solid gray;\r\n    color: grey;\r\n    pointer-events: none;\r\n  }\r\n\r\n  .select-arrow {\r\n    margin-left: auto;\r\n    margin-right: 20px;\r\n    transition: all 150ms ease;\r\n  }\r\n\r\n  .caret-down {\r\n    background-image: url('data:image/svg+xml;utf8, <svg focusable=\"false\" viewBox=\"0 0 16 16\" xmlns=\"http://www.w3.org/2000/svg\" name=\"chevron-down\" aria-label=\"Close menu\" role=\"img\"><path d=\"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z\"/></svg>');\r\n    background-position: center center;\r\n    background-size: cover;\r\n    background-repeat: no-repeat;\r\n    width: 15px;\r\n    height: 15px;\r\n    transform: rotate(0deg);\r\n  }\r\n\r\n  .caret-up {\r\n    background-image: url('data:image/svg+xml;utf8, <svg focusable=\"false\" viewBox=\"0 0 16 16\" xmlns=\"http://www.w3.org/2000/svg\" name=\"chevron-down\" aria-label=\"Close menu\" role=\"img\"><path d=\"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z\"/></svg>');\r\n    background-position: center center;\r\n    background-size: cover;\r\n    background-repeat: no-repeat;\r\n    width: 15px;\r\n    height: 15px;\r\n    transform: rotate(180deg);\r\n  }\r\n\r\n  .select-panel-wrap {\r\n    width: inherit;\r\n    height: inherit;\r\n    border: 1px gray solid;\r\n    border-radius: 3px;\r\n  }\r\n\r\n  .select-panel {\r\n    display: flex;\r\n    flex-direction: column;\r\n    padding: 5px;\r\n    overflow: auto;\r\n    max-height: 150px;\r\n    border: unset;\r\n  }\r\n\r\n  .search-input {\r\n    height: 48px;\r\n    padding-left: 10px;\r\n    width: 100%;\r\n    border-left: unset;\r\n    border-right: unset;\r\n  }\r\n\r\n  .placeholder {\r\n    color: #a2a2a2;\r\n    font-weight: lighter;\r\n  }\r\n\r\n  .option {\r\n    padding: 10px;\r\n  }\r\n\r\n  .select-value {\r\n    padding: 10px;\r\n  }\r\n\r\n</style>\r\n\r\n\r\n<div (ngModelChange)=\"onChange($event)\" name=\"select\"  class=\"select-trigger\" [ngClass]=\"{ active: panelOpen, focus: focused, dissable: isDissabled }\" (click)=\"onOpen()\"\r\n  cdkOverlayOrigin #origin=\"cdkOverlayOrigin\" #trigger>\r\n  <div class=\"select-value\">\r\n    {{ displayOption ? displayOption.value : \"\" }}\r\n  </div>\r\n\r\n  <div *ngIf=\"!displayOption?.value\" class=\"placeholder\">\r\n    {{ placeholder }}\r\n  </div>\r\n  <div class=\"select-arrow\" [ngClass]=\"{ 'caret-down': !panelOpen, 'caret-up': panelOpen }\"></div>\r\n</div>\r\n<ng-template cdkConnectedOverlay cdkConnectedOverlayHasBackdrop cdkConnectedOverlayLockPosition\r\n  cdkConnectedOverlayBackdropClass=\"cdk-overlay-transparent-backdrop\" [cdkConnectedOverlayOrigin]=\"origin\"\r\n  [cdkConnectedOverlayOpen]=\"panelOpen\" [cdkConnectedOverlayWidth]=\"triggerRect?.width\" (backdropClick)=\"close()\"\r\n  (attach)=\"onAttach()\">\r\n  <div class=\"select-panel-wrap\" [formGroup]=\"searchForm\" [@selectAnim]>\r\n    <div class=\"eui-input-group-addon\">\r\n      <input class=\"search-input\" formControlName=\"search\" id=\"text-model-driven-addon\" placeholder=\"search...\" />\r\n      <div *ngIf=\"!isReadonly\" class=\"eui-input-group-addon-item\"><span euiIcon\r\n          iconClass=\"eui-icon eui-icon-search\"></span></div>\r\n    </div>\r\n    <div class=\"select-panel\" tabindex=\"-1\" role=\"listbox\" #panel\r\n      (scroll)=\"!isLoading && !isLast? onScroll($event) : ''\">\r\n      <ng-content class=\"option\"></ng-content>\r\n    </div>\r\n  </div>\r\n</ng-template>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i1.ViewportRuler }]; }, propDecorators: { isLast: [{
                type: Input
            }], isLoading: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], formControl: [{
                type: Input
            }], filterQuery: [{
                type: Output
            }], takeNextPage: [{
                type: Output
            }], onSelectValue: [{
                type: Output
            }], tabIndex: [{
                type: HostBinding,
                args: ['attr.tabIndex']
            }], role: [{
                type: HostBinding,
                args: ['attr.role']
            }], autocomplete: [{
                type: HostBinding,
                args: ['attr.aria-autocomplete']
            }], trigger: [{
                type: ViewChild,
                args: ['trigger']
            }], connectedOverlay: [{
                type: ViewChild,
                args: [CdkConnectedOverlay, { static: true }]
            }], panel: [{
                type: ViewChild,
                args: ['panel']
            }], selectOptions: [{
                type: ContentChildren,
                args: [AtSelectOptionComponent, { descendants: true }]
            }], onKeyDown: [{
                type: HostListener,
                args: ['keydown', ['$event']]
            }], onFocus: [{
                type: HostListener,
                args: ['focus']
            }], onBlur: [{
                type: HostListener,
                args: ['blur']
            }] } });

class AtSelectModule {
}
AtSelectModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AtSelectModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.3", ngImport: i0, type: AtSelectModule, declarations: [AtSelectOptionComponent,
        AtSelectComponent], imports: [CommonModule,
        ReactiveFormsModule,
        BrowserAnimationsModule,
        FormsModule,
        OverlayModule,
        BrowserModule], exports: [AtSelectComponent,
        AtSelectOptionComponent] });
AtSelectModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectModule, imports: [CommonModule,
        ReactiveFormsModule,
        BrowserAnimationsModule,
        FormsModule,
        OverlayModule,
        BrowserModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.3", ngImport: i0, type: AtSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        AtSelectOptionComponent,
                        AtSelectComponent,
                    ],
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        BrowserAnimationsModule,
                        FormsModule,
                        OverlayModule,
                        BrowserModule
                    ],
                    exports: [
                        AtSelectComponent,
                        AtSelectOptionComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of at-select
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AtSelectComponent, AtSelectModule, AtSelectOptionComponent };
//# sourceMappingURL=at-select.mjs.map
