import { ViewportRuler } from '@angular/cdk/scrolling';
import { ControlValueAccessor } from '@angular/forms';
import { ChangeDetectorRef, ElementRef, OnDestroy, OnInit, EventEmitter } from '@angular/core';
import { ActiveDescendantKeyManager } from '@angular/cdk/a11y';
import { FormGroup, FormControl } from '@angular/forms';
import { AtSelectOptionComponent } from './at-select-option.component';
import * as i0 from "@angular/core";
export declare class AtSelectComponent implements OnInit, OnDestroy, ControlValueAccessor {
    private elementRef;
    private changeDetectorRef;
    private viewportRuler;
    get empty(): boolean;
    isLast: boolean;
    isLoading: boolean;
    placeholder: string;
    isReadonly: boolean;
    value?: any;
    formControl: FormControl;
    displayOption: SelectedOption;
    selectedOption: AtSelectOptionComponent;
    panelOpen: boolean;
    focused: boolean;
    isDissabled: boolean;
    onChange: (value: any) => void;
    onTouched: () => void;
    searchForm: FormGroup<{
        search: FormControl<any>;
    }>;
    triggerRect: ClientRect;
    keyManager: ActiveDescendantKeyManager<AtSelectOptionComponent>;
    filterQuery: EventEmitter<string>;
    takeNextPage: EventEmitter<void>;
    onSelectValue: EventEmitter<any>;
    tabIndex: number;
    role: string;
    autocomplete: string;
    private trigger;
    private connectedOverlay;
    private panel;
    private readonly destroy$;
    private selectOptions;
    constructor(elementRef: ElementRef, changeDetectorRef: ChangeDetectorRef, viewportRuler: ViewportRuler);
    onKeyDown(event: any): void;
    onFocus(): void;
    onBlur(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    ngOnInit(): void;
    ngAfterContentInit(): void;
    onRefresh(): void;
    onAttach(): void;
    onSelect(option: AtSelectOptionComponent): void;
    onFilter(): void;
    onScroll(event: any): void;
    onOpen(): void;
    close(): void;
    ngOnDestroy(): void;
    private prepareViewportRuler;
    private initKeyManager;
    private handleClosedKeyDown;
    private handleOpenKeyDown;
    private focus;
    private highlightOption;
    private scrollPosition;
    private updateRect;
    static ɵfac: i0.ɵɵFactoryDeclaration<AtSelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AtSelectComponent, "at-select", never, { "isLast": "isLast"; "isLoading": "isLoading"; "placeholder": "placeholder"; "formControl": "formControl"; }, { "filterQuery": "filterQuery"; "takeNextPage": "takeNextPage"; "onSelectValue": "onSelectValue"; }, ["selectOptions"], ["*"], false>;
}
export interface SelectedOption {
    value: string;
}
